unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.Buttons, Vcl.ExtCtrls, system.Character,
  system.Diagnostics;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    ClearBtn: TBitBtn;
    PrecisionEdit: TLabeledEdit;
    GroupBox3: TGroupBox;
    CalcBtn: TBitBtn;
    XinEdit: TLabeledEdit;
    Edit1: TEdit;
    CheckBox1: TCheckBox;
    procedure ClearBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CalcBtnClick(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses log, Velthuis.Bigdecimals, Velthuis.bigintegers;

// L
function InPrecision(s: string): integer;
var
  ch : integer;
begin
  val(s, Result, ch);
  if ch <> 0 then begin
    application.MessageBox('LɊԈႢ܂B','',0);
    result := -1;
    exit;
  end;
  if Result < 1 then begin
    application.MessageBox('L͂PȏɂĂB','',0);
  end;
  if Result > 2500 then begin
    application.MessageBox('L2500ɂĂB','',0);
    result := -1;
  end;
end;

// w̖ꍇ̐lmF
// x:  'e','E'̂Ȃ
// ca:  0 '.' ꍇ@1 Ȃꍇ
// 肪ꍇ 0Ԃ܂
function numeralfloatcheck(x: string; ca: byte): integer;
var
  len, dn, n, d : integer;
  num, numb : string;
  flg : boolean;
  snum : integer;
begin
  len := length(x);                   // 
  snum := 1;
  num := x[1];                        // P
  dn := 0;
  flg := true;
  if num = '+' then inc(snum);          // '+' pX
  if num = '-' then inc(snum);          // '-' pX
  if num = '.' then begin               // '.'
    inc(dn);                            // '.'JEgCNg
    inc(snum);                          // pX
  end;
  for n := snum to len do begin       // snum len lmF
    num := x[n];
    if num = '.' then begin             // '.'
      inc(dn);                          // '.'JEgCNg
      continue;                         // pX
    end;
    flg := false;
    for d := 0 to 9 do begin            // 0`9̒lmF
      numb := inttostr(d);
      if numb = num then begin
        flg := true;
        break;
      end;
    end;
    if flg = false then break;
  end;
  if ca = 0 then begin                // '.'
    if dn > 1 then flg := false;        // '.'1Ȃ0k
  end
  else                                // '.'
    if dn > 0 then flg := false;        // '.'MG

  if flg then result := 0
         else result := 1;
end;

// ͊mF
function incheck(s, m: string): boolean;
const
  ec = 'e';
  eo = 'E';
  dt = '.';
var
  fs, es : string;
  ch, p, po, leng : integer;
begin
  result := false;
  p := pos(ec, s);             // 'e' ̈ʒu
  po := pos(eo, s);            // 'E' ̈ʒu
  p := p + po;
  if p = 0 then begin          // 'e'  'E' 
    ch := numeralfloatcheck(s, 0);    // '.'ŊmFĂǂ
    if ch <> 0 then begin
      application.MessageBox(' ͒lɊԈႢ܂B','',0);
      exit;
    end;
    result := true;
    exit;
  end;
  leng := length(s);
  fs := '';
  fs := copy(s, 1, p - 1);            // 'e'̑O̕o
  es := '';
  es := copy(s, p + 1, leng - p);     // 'e'̌̕o
  ch := numeralfloatcheck(fs, 0);     // 'e'̑O̊̕mF '.'ŊmFĂǂ
  if ch <> 0 then begin
    application.MessageBox(' ͒lɊԈႢ܂B','',0);
    exit;
  end;
  if es <> '' then begin              // 'e'̌̕mF
    ch := numeralfloatcheck(es, 1);   // '.'ŊmF
    if ch <> 0 then begin
      application.MessageBox(' ͒lɊԈႢ܂B','',0);
      exit;
    end;
  end;
  result := true;
end;

procedure TForm1.CalcBtnClick(Sender: TObject);
const
  MAXX = '1e500000';
  MINX = '1e-500000';
var
  x, y, mnx: bigdecimal;
  Precision : integer;
  StopWatch : TStopwatch;
  ElapsedMillseconds : Int64;
begin
  if not incheck(XinEdit.Text, 'x') then exit;
  x := XinEdit.Text;
  mnx := MAXX;
  if x > mnx then begin
    application.MessageBox(' ͒l傫܂B','',0);
    exit;
  end;
  mnx := MINX;
  if x < mnx then begin
    application.MessageBox(' ͒l܂B','',0);
    exit;
  end;
  Precision := InPrecision(PrecisionEdit.Text); // L
  if Precision < 1 then exit;
  StopWatch := TStopwatch.StartNew;
  BigDecimal.DefaultPrecision := Precision;
  if checkbox1.Checked = false then
    y := log_big(x, 0)
  else
    y := log_big(x, 1);
  ElapsedMillseconds := StopWatch.ElapsedMilliseconds;
  Edit1.text := 'Z = ' + intTostr(ElapsedMillseconds) + 'msec';
  memo1.Lines.Append(y.ToPlainString);
end;


procedure TForm1.ClearBtnClick(Sender: TObject);
begin
  Memo1.Clear;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  memo1.Clear;
end;

end.
